﻿//在程序编译后，生成了exe可执行程序，未执行该程序前分为两个区域

//代码区
//存放CPU执行的机器指令
//代码区是共享的，共享的目的是对于频繁被执行的程序，只需要在内存中有一份代码即可
//代码区是只读的，使其只读的原因是防止程序意外地修改了它的指令
 

//全局区
//全局变量和静态变量存放在此
//全局区还包括了常量区，字符串常量和其他常量也存放在此
//该区域的数据在程序结束后由操作系统释放


#if(0)

#include <iostream>


//全局变量
int g_a = 10;
int g_b = 10;


//const修饰的全局变量，全局常量
const int c_g_a = 10;
const int c_g_b = 10;

int main()
{
	//全局区


	//全局变量  、  静态变量  、 常量

	//创建普通局部变量
	int a = 10;

	int b = 10;

	std::cout << "局部变量a的地址为 ：" << (int)&a << std::endl;
	std::cout << "局部变量b的地址为 ：" << (int)&b << std::endl;

	std::cout << "全局变量g_a的地址为 ：" << (int)&g_a << std::endl;
	std::cout << "全局变量g_b的地址为 ：" << (int)&g_b << std::endl;

	//静态变量   在普通变量前面加static，属于静态变量
	static int s_a = 10;
	static int s_b = 10;

	std::cout << "静态变量s_a的地址为 ： " << (int)&s_a << std::endl;
	std::cout << "静态变量s_b的地址为 ： " << (int)&s_b << std::endl;


	//常量
	//字符串常量
	
	std::cout << "字符串常量的地址为 ：" << (int)&"hello world" << std::endl;

	//const修饰的变量
	//const修饰的全局变量
	std::cout << "全局常量 c_g_a 的地址为 ：" << (int)&c_g_a << std::endl;
	std::cout << "全局常量 c_g_b 的地址为 ：" << (int)&c_g_b << std::endl;

	

	//const修饰的局部变量
	const int c_l_a = 10;     // c-const   g-global   l-local
	const int c_l_b = 10;


	std::cout << "局部变量 c_l_a 的地址为 ： " << (int)&c_l_a << std::endl;
	std::cout << "局部变量 c_l_b 的地址为 ： " << (int)&c_l_b << std::endl;



	
	system("pause");

	return 0;

}

#endif



//总结：


//⚪C++中在程序运行前分为全局区和代码区
//⚪代码区特点是共享和只读
//⚪全局区中存放全局变量、静态变量、常量
//⚪常量区中存放const修饰的全局常量 和 字符串常量