﻿//4、2对象的初始化和清理

//⚪生活中我们购买的电子产品基本都有出厂设置，在某一天我们不用的时候也会删除一些自己信息数据保障安全
//⚪C++中的面向对象来源于生活，每个对象也都会有初始设置以及对象销毁前的清理数据的设置

//4、2、1构造函数和析构函数
//对象的初始化和清理也是两个非常重要的安全问题
//一个对象或者变量没有初始状态，对其使用后果是未知
//同样的使用完一个对象或变量，没有及时清理，也会造成一定安全问题

//C++利用了构造函数和析构函数解决上述问题，这两个函数将会被编译器自动调用，完成对象初始化和清理工作。
//对象的初始化和清理工作是编译器强制要我们做的事情，因此如果我们不提供构造和析构，编译器会提供编译器提供的构造函数和析构函数是空实现

//构造函数：主要作用在于创建对象时为对象的成员属性赋值，构造函数由编译器自动调用，无需手动调用
//析构函数：主要作用在于对象销毁前系统自动调用，执行一些清理工作

//构造函数语法：类名(){}
//1、构造函数，没有返回值也不写void
//2、函数名称与类名相同
//3、构造函数可以有参数，因此可以发生重载
//4、程序在调用对象的时候会自动调用构造，无需手动调用，而且只会调用一次


//析构函数语法：~类名(){}
//1、析构函数，没有返回值也不写void
//2、函数名称与类名相同，在名称前面加上符号~
//3、析构函数不可以有参数，因此不可以发生重载
//4、程序在对象销毁前会自动调用析构，无需手动调用，而且只会调用一次


#if(0)


#include <iostream>


class Person
{
public:

	//1、构造函数  进行初始化操作

	Person()
	{
		std::cout << "Person构造函数的调用" << std::endl;
	}


	//2、析构函数  进行清理的操作

	~Person()
	{
		std::cout << "Person的析构函数调用" << std::endl;
	}

};

//构造和析构都是必须有实现，如果我们自己不提供，编译器会提供一个空实现的构造和析构

void test01()
{
	Person p;    //在栈上的数据，test01执行完毕后，释放这个对象
}

int main()
{

	//test01();

	Person p;

	system("pause");

	return 0;

}


#endif